GammalL.ib - Bug #1058

Use of uninitialised values in GHealpix::dir2pix if m_coordsys == 3 or 4
01/05/2014 11:57 PM - Deil Christoph
Description

Just for fun | ran the clang static analyser on gammalib and it found a handful of issues.
http://clang-analyzer.llvm.org

It's super-simple, just write “scan-build-mp-3.3 ./configure --enable-debug” (available via “sudo port install clang-3.3")
One is in GHealpix::dir2pix and is described in the attached HTML file.

| think this is a real bug (I did not write a test), when m_coordsys == 3 or 4.
int m_coordsys; //!< O=celestial, 1=galactic, 2=ecl, 3=hel, 4=sg|

A simple solution to fix this issue would be to throw in the switch default?

But really using integer constants (0, 1, 2, 3, 4) across multiple classes (GHealpix, GSkyProjection) doesn't seem a good solution.
enum?

Associated revisions

Revision 1643814d - 01/08/2014 03:14 PM - Deil Christoph

Remove extra non-implemented coordinate systems from GSkyProjection (fixes #1058).

History

#1 - 01/06/2014 11:36 AM - Deil Christoph
- File scan-build-2014-01-06-1.tar.gz added

I've attached the static analyser output report.
The issues found are:

e Dead assignments in GWcsMER.cpp, GSkymap.cpp

e Dereferences of null pointer in GFitsTableBitCol.cpp, GMatrixSparse.cpp, GFitsTable.cpp, GMatrixSymmetric.cpp, GFitsTableBitCol.cpp
¢ Double frees in GFitsHeaderCard.cpp

® The uninitialised argument value in GHealpix.cpp mentioned above.

I'm not 100% sure all of those are real issues that can happen, but probably worth a look.

#2 - 01/06/2014 11:41 AM - Deil Christoph

Pull request for one commit: "Fix some unimportant compiler warnings to have a clean build."
https://github.com/cdeil/gammalib/commit/b4fb8da329a6c9d94c2553a393dac4ac85506ddc

#3 - 01/06/2014 11:36 PM - Knddliseder Jiirgen
Deil Christoph wrote:
http://clang-analyzer.llvm.org
https://github.com/cdeil/gammalib/commit/b4fb8da329a6c9d94c2553a393dac4ac85506ddc

Pull request for one commit: "Fix some unimportant compiler warnings to have a clean build."

https://github.com/cdeil/gammalib/commit/b4fb8da329a6c9d94c2553a393dac4ac85506ddc

Applied the commit.

#4 - 01/06/2014 11:43 PM - Knddliseder Jiirgen
Deil Christoph wrote:

I've attached the static analyser output report.
The issues found are:

e Dead assignments in GWcsMER.cpp, GSkymap.cpp

Corrected.

e Dereferences of null pointer in GFitsTableBitCol.cpp, GMatrixSparse.cpp, GFitsTable.cpp, GMatrixSymmetric.cpp, GFitsTableBitCol.cpp

Not bugs.

¢ Double frees in GFitsHeaderCard.cpp

Not bugs.

® The uninitialised argument value in GHealpix.cpp mentioned above.

This is indeed a bug. The HealPix code implements indeed only the 0 and 1 coordinate systems. Probably the >1 coordinate systems should be
removed from GSkyProjection as they are not really supported by GammalLib anyways (e.g. GSkyDir does not provide any conversion for these
coordinates).

I'm not 100% sure all of those are real issues that can happen, but probably worth a look.
https://github.com/cdeil/gammalib/commit/b4fb8da329a6c9d94c2553a393dac4ac85506ddc

#5 - 01/08/2014 02:54 PM - Deil Christoph

- Status changed from New to Pull request

Pull request: https:/github.com/cdeil/gammalib/compare/gammalib:devel...cdeil:issue_1058

| still think the raw 0 and 1 constants should be replaced by something more readable ... not sure how best to implement it though.

e #define, const, enum ?
e | ocated where?

#6 - 01/08/2014 04:03 PM - Knddliseder Jiirgen

| agree that an enumerator should be used ultimately.

Concerning your changes, | prefer of not changing the default argument of the HEALPix constructor, as some existing code may already rely on this.

#7 - 01/08/2014 05:48 PM - Knodlseder Jiirgen
- Status changed from Pull request to Closed

- % Done changed from 0 to 100

Pushed into devel.

#8 - 01/10/2014 09:21 AM - Deil Christoph

There's two reasons why | changed the default coordinate system in the HEALPIX constructor from Galactic to Equatorial:

e There are ambiguities in the definition of Galactic coordinates (see references here:

http://docs.astropy.org/en/latest/api/astropy.coordinates.builtin_systems.Galactic.html)
¢ The default coordinate system in GSkyProjection, the base class of GHealpix is equatorial and this default should be consistent within
Gammalib:

http://gammalib.sourceforge.net/doxygen/GSkyProjection_8cpp_source.html#100211

| don't think backwards compatibility should stop any possible improvements in Gammalib at this very early stage.

#9 - 01/10/2014 10:37 AM - Knddlseder Jiirgen
Deil Christoph wrote:

There's two reasons why | changed the default coordinate system in the HEALPIX constructor from Galactic to Equatorial:

e There are ambiguities in the definition of Galactic coordinates (see references here:
http:/ n/l /api i iltin lactic.html

... but we use galactic coordinates widely despite these ambiguities, and it works ...

e The default coordinate system in GSkyProjection, the base class of GHealpix is equatorial and this default should be consistent within
Gammalib:
http://gammalib.sourceforge.net/doxygen/GSkyProjection_8cpp_source.htmi#10021 1
https://github.com/cdeil/gammalib/compare/gammalib:devel...cdeil:issue_1058
http://docs.astropy.org/en/latest/api/astropy.coordinates.builtin_systems.Galactic.html
http://gammalib.sourceforge.net/doxygen/GSkyProjection_8cpp_source.html#l00211
http://docs.astropy.org/en/latest/api/astropy.coordinates.builtin_systems.Galactic.html
http://gammalib.sourceforge.net/doxygen/GSkyProjection_8cpp_source.html#l00211

Good point. | have not thought about this. So | agree to change to EQU smile.png

Files
report-1cpyQQ.html 118 KB 01/05/2014 Deil Christoph
scan-build-2014-01-06-1.tar.gz 5.01 MB 01/06/2014 Deil Christoph
